/*
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
// Produced by:
//  Silicon Grail Corporation
//  736 Seward St
//  Hollywood, CA
//  USA 90038
//  323-871-9100
//
// NAME:	CPI_FileImportProvider
//
// COMMENTS:
//
*/


#ifndef _CPI_FileImportProvider_h_
#define _CPI_FileImportProvider_h_

#include <CPI/CPI_Base.h>
#include <CPI/CPI_FileImporter.h>

#ifdef __cplusplus
extern "C" {
#endif

/*
//////////////////////////////////////////////////////////////////////////////
//
// Arguments:
//	None
// Return Value:
//  CPI_Bool - should return CPI_TRUE if the plugin was initialized
//			   successfully
//
*/
typedef CPI_Bool	 (*RPI_FileImporterInitFn)( void );


/*
//////////////////////////////////////////////////////////////////////////////
//
// Arguments:
//	None
// Return Value:
//	CPI_Bool - should return CPI_TRUE if the plugin was shut down successfully
//
*/
typedef CPI_Bool	 (*UPI_FileImporterShutDownFn)( void );


/*
//////////////////////////////////////////////////////////////////////////////
//
// Arguments:
//  CPI_Metadata fileInfo - This contains information which was used to open
//							'handle'.  This metadata contains the filename,
//							filemanager, and other device information. 
//  CPI_DeviceHandle handle - This is the file which you should read your data
//                            from.
//
// Return Value:
// 	CPI_Bool - should return CPI_TRUE if your plugin can interpret this file
//			   correctly.
//
*/
typedef CPI_Bool	 (*RPI_FileImporterCanImportFn)( CPI_Metadata	  fileInfo,
													 CPI_DeviceHandle handle );
	
	
/*
//////////////////////////////////////////////////////////////////////////////
//
// Arguments:
//  CPI_Metadata fileInfo - This contains information which was used to open
//							'handle'.  This metadata contains the filename,
//							filemanager, and other device information. 
//	CPI_DeviceHandle handle - This is the file which you should read your data
//                            from.
//
// Return Value:
//	CPI_Bool - should return CPI_TRUE if the file was loaded sucessfully
//
*/
typedef CPI_Bool	 (*RPI_FileImporterReadFn)( CPI_Metadata	 fileInfo,
												CPI_DeviceHandle handle );


/*
// For any optional (upi labeled) functions you don't wish to provide,
// fill in NULL
*/
typedef struct
{
	RPI_PluginInfo				 rpiPluginInfo;

	RPI_FileImporterInitFn		 rpiFileImporterInit;
	UPI_FileImporterShutDownFn	 upiFileImporterShutDown;

	RPI_FileImporterCanImportFn	 rpiFileImporterCanImport;
	RPI_FileImporterReadFn		 rpiFileImporterRead;

	const char					*upiExtensions;
} RPI_FileImportInfo;

#ifdef __cplusplus
}
#endif

#endif /* _CPI_FileImportProvider_h_ */
