//
// PROPRIETARY INFORMATION.  This software is proprietary to
// Silicon Grail Corporation, and is not to be reproduced,
// transmitted, or disclosed in any way without written permission.
//
// Produced by:
//  Kimball Thurston
//  Silicon Grail Corporation
//  736 Seward St
//  Hollywood, CA
//  USA 90038
//  323-871-9100
//

#ifndef _CPI_Register_h_
#define _CPI_Register_h_

#ifdef __cplusplus
extern "C" {
#endif

CPIDSOEXPORT CPI_Bool	rpiPluginInit( void );
CPIDSOEXPORT void		upiPluginCleanup( void );

CPIDSOIMPORT CPI_Bool	cpiRegisterDevice( const RPI_DeviceInfo	*info );
CPIDSOIMPORT void		cpiUnregisterDevice( const char			*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterFileImporter( const RPI_FileImportInfo *info );
CPIDSOIMPORT void		cpiUnregisterFileImporter( const char	*name );
	
CPIDSOIMPORT CPI_Bool	cpiRegisterFileManager( const RPI_FMInfo	*info );
CPIDSOIMPORT void		cpiUnregisterFileManager( const char		*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterImageReader( const RPI_ImageInfo	*info );
CPIDSOIMPORT void		cpiUnregisterImageReader( const char		*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterNode( const RPI_NodeInfo	*info );
CPIDSOIMPORT void		cpiUnregisterNode( const char		*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterImageOp( const RPI_ImageOpInfo	*info );
CPIDSOIMPORT void		cpiUnregisterImageOp( const char			*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterLUT( const RPI_LUTInfo	*info );
CPIDSOIMPORT void		cpiUnregisterLUT( const char		*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterOverlay( const RPI_OverlayInfo	*info );
CPIDSOIMPORT void		cpiUnregisterOverlay( const char			*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterExpression( const RPI_ExpressionInfo	*info );
CPIDSOIMPORT void		cpiUnregisterExpression( const char	  			*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterCurveIO( const RPI_CurveIOInfo	*info );
CPIDSOIMPORT void		cpiUnregisterCurveIO( const char	*name );

CPIDSOIMPORT CPI_Bool	cpiRegisterScriptOption( const RPI_ScriptInfo	*info );
CPIDSOIMPORT void		cpiUnregisterScriptOption( const char	*name );

#ifdef __cplusplus
}
#endif

#endif /* _CPI_Register_h_ */

